﻿
using SampleListViewUpdate.Model;
using Syncfusion.ListView.XForms;
using Syncfusion.ListView.XForms.Control.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SampleListViewUpdate
{
    public partial class MainPage : ContentPage
    {

        ExtendedScrollView scrollView = new ExtendedScrollView();
        VisualContainer visualContainer = new VisualContainer();


        public List<ValueModel> itemList { get; set; } = new List<ValueModel>();
        public List<ValueModel> itemList2 { get; set; } = new List<ValueModel>();


        System.Timers.Timer timer;


        private int counter = 0;
        private double progress = 1;


        public MainPage()
        {
            InitializeComponent();

            scrollView = new ExtendedScrollView();
            visualContainer = new VisualContainer();
            itemList = new List<ValueModel>();
            itemList2 = new List<ValueModel>();

            //start parameters for autoupdate
            counter = 0;
            progress = 1;
            ProgressBarUpdate.Progress = progress;
            ProgressBarUpdate2.Progress = progress;

            timer = new System.Timers.Timer(1000);      //1 second
            timer.Elapsed += Timer_Elapsed;
        }


        protected override void OnAppearing()
        {
            base.OnAppearing();

            LoadData();

            timer.Start();
        }




        private void Timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timer.Enabled = false;      //nessesery!

            LoadDataAutoUpdate();

            timer.Enabled = true;
        }




        private async void LoadData()
        {

            //------------------------- AutoUpdate 1 -------------------------------------- with animation
            try
            {
                scrollView = new ExtendedScrollView();
                itemList = new List<ValueModel>();

                scrollView = ListViewValue.GetScrollView();


                for (int i = 0; i < 23; i++)
                {
                    Random r = new Random();
                    itemList.Add(new ValueModel() { Name = GetRandomString(6), ValueUnit = r.Next(500).ToString() + " kWh", Group = "Test", DateTime = DateTime.Now.ToString(), Favourite = true });
                }

                ListViewValue.ItemsSource = itemList;

                ListViewValue.ScrollTo(scrollView.ScrollY);
            }
            catch (Exception exe)
            {
                string err = exe.Message;
            }

            //------------------------- AutoUpdate 2 -------------------------------------- without animation but not working on Android
            try
            {
                visualContainer = new VisualContainer();
                itemList2 = new List<ValueModel>();

                visualContainer = ListViewValue2.GetVisualContainer();
                var scrollLineIndex = visualContainer.ScrollRows.ScrollLineIndex;

                for (int i = 0; i < 23; i++)
                {
                    Random r = new Random();
                    itemList2.Add(new ValueModel() { Name = GetRandomString(5), ValueUnit = r.Next(500).ToString() + " C", Group = "Test2", DateTime = DateTime.Now.ToString(), Favourite = true });
                }

                ListViewValue2.ItemsSource = itemList2;

                await Task.Delay(1000);
                ListViewValue2.LayoutManager.ScrollToRowIndex(scrollLineIndex, true);
            }
            catch (Exception exe)
            {
                string err = exe.Message;
            }
        }




        public static String GetRandomString(int length)
        {
            Thread.Sleep(2);

            string characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            System.Random random = new System.Random();
            String ret = new string(Enumerable.Repeat(characters, length).Select(s => s[random.Next(s.Length)]).ToArray());
            return ret;
        }



        private void LoadDataAutoUpdate()
        {
            try
            {
                if (counter == 5)        // 5 second
                {
                    progress = 1;
                    counter = 0;

                    Device.BeginInvokeOnMainThread(() => LoadData());

                    Device.BeginInvokeOnMainThread(() => ProgressBarUpdate.Progress = progress);
                    Device.BeginInvokeOnMainThread(() => ProgressBarUpdate2.Progress = progress);

                }
                else
                {
                    counter += 1;
                    progress = progress - 0.2;

                    Device.BeginInvokeOnMainThread(() => ProgressBarUpdate.Progress = progress);
                    Device.BeginInvokeOnMainThread(() => ProgressBarUpdate2.Progress = progress);
                }
            }
            catch (Exception exe)
            {
                string err = exe.Message;
            }
        }

    }

}
